(defun c:bw_view   (/ $VALUE
		      *ERROR*
		      *ODWG*
		      *VERDATE*
		      *VIEWNAME*
		     
		      COUNT
		      DCL_ID
		      DEL?
		      DIAALL
		      DIALOGEND
		      DIANAME
		      HOOK
		      _DIALOG
		   ) ;_ end /

  
  ;; globals variables
  ;; *viewName* *oDwg*
  
  (vl-load-com)
  (setq	*error*	     bw_fehler
	*VerDate* "16.05.2003"
	dcl_id	     (load_dialog "bw_view.dcl")
	*oDwg*	     (substr (getvar "dwgname") 1 (- (strlen (getvar "dwgname")) 4))
	count	     0
  ) ;_ end  setq
  (if dcl_id
    (if	(not (new_dialog "BW_DIAVIEWER" dcl_id))
      (exit)
    ) ;_ end  if
    (exit)
  ) ;_ endif
  
  ;; fill imagebuttons
  ;;------------------
  
  (repeat 16
    (if	(= (strcase (chr (+ 65 count)))
	   (cdr (assoc 2 (tblsearch "VIEW" (strcase (chr (+ 65 count))))))
	) ;_ end =
      (bw_fillimage (chr (+ 65 count)))
    ) ;_ end if
    (setq count (1+ count))
  ) ;_ end repeat
  
  ;;-------------------------
  
  ;; dialog
  (mode_tile   "chancel" 2)
  (action_tile "chancel" "(done_dialog 0)")
  (action_tile "make_set" "(setq Del? nil)")
  (action_tile "L"     "(setq Del? T)")
  (action_tile "LA"    "(done_dialog 2)")
  (action_tile "REFR"   "(done_dialog 3)")
  (action_tile "help"   "(bw_help *VerDate* \"ViewerHelpText.txt\" \"Benwisch's DiaViewer - bw_View.lsp (.dcl) -->Stand : \")")
  (setq DialogEnd (start_dialog))
  (unload_dialog dcl_id)
  (cond
;;; **************************************************************************
    
    ((= DialogEnd 1) ;_ okay
     (if Del? ;| delete current view-button ?? |;
       (progn
	 (if (and (/= *viewName* nil)
		  (= *viewName* (cdr (assoc 2 (tblsearch "VIEW" *viewName*))))
	     ) ;_ end and
	   (progn (setq
		    DiaName (strcat (getvar "dwgprefix") "BW_DIAs\\" *oDwg* "-" *viewName*)
		  ) ;_ end setq
		  (command "_del" (strcat DiaName ".sld"))
		  (command "'_-view" "l" *viewName*)
		  (princ (strcat "\nLsche aktuellen Ausschnitt ---> <" *viewName* ">  "))
		  (c:bw_view)
	   ) ;_ end progn
	   (progn
	     (alert
	       "Fr diese Schaltflche gibt es keinen Ausschnitt der gelscht werden kann !!"
	     ) ;_ end alert
	     (princ)
	   ) ;_ end progn
	 ) ;_ end if
       ) ;_ end progn
       (progn (if (/= *viewName* nil)
		(if (= *viewName* (cdr (assoc 2 (tblsearch "VIEW" *viewName*))))
		  (bw_getView *viewName*)
		  (bw_creaView *viewName*)
		) ;_ end if
		(princ "\n...kein Ausschnitt gewhlt = Programmende")
	      ) ;_ end if
       ) ;_ end progn
     ) ;_ end if
    ) ;_ DialogEnd okay
    
;;; **************************************************************************
        
    ((= DialogEnd 2) ;_ delete ALL
     (setq diaall  (strcat (getvar "dwgprefix")
			   "BW_DIAs\\"
			   (substr (getvar "dwgname") 1 (- (strlen (getvar "dwgname")) 4))
			   "*.sld"
		   ) ;_ end  strcat
	   _dialog (load_dialog "bw_view.dcl") 
	   hook   "1"
     ) ;_ end  setq
     (if _dialog
       (new_dialog "fragschni" _dialog)
       (progn (alert (strcat "Kann Dialog " _dialog " nicht initialisieren!")) (exit))
     ) ;_ end if
     (action_tile "LAA"    "(setq hook	  $VALUE)")
     (action_tile "chancel" "(done_dialog 0)")
     (action_tile "accept"  "(done_dialog 1) ")
     (setq DialogEnd (start_dialog))
     (unload_dialog dcl_id)
     (cond
       ((= DialogEnd 0) (princ "\n>>NICHTS<< gelscht !!"))
       ((= DialogEnd 1)
	(if (= hook "1")
	  (progn (command "del" diaall)
		 (command "_-view" "l" "*")
		 (princ "\nAlle DIA's inklusive der Ausschnitte erfolgreich gelscht. ")
	  ) ;_ end progn
	  (progn
	    (command "del" diaall)
	    (princ
	      "\nAlle DIA's erfolgreich gelscht. Gespeicherte Ausschnitte bleiben erhalten. "
	    ) ;_ end princ
	  ) ;_ end progn
	) ;_ end if
       )
     ) ;_ end cond
    ) ;_ DialogEnd lschen alles
    
;;; **************************************************************************
        
    ((= DialogEnd 3) ;_ Refreshing
     (setq *viewName*	nil
	   count 0
     ) ;_ end setq
     (repeat 16
       (if (= (strcase (chr (+ 65 count)))
	      (cdr (assoc 2 (tblsearch "VIEW" (strcase (chr (+ 65 count))))))
	   ) ;_ end =
	 (bw_refView (chr (+ 65 count)))
       ) ;_ end if
       (setq count (1+ count))
     ) ;_ end repeat
     (if (/= *viewName* nil)
       (progn (princ "\nAlle Dia-Ausschnitte aufgefrischt, starte neu...\n")
	      (c:bw_view)
       ) ;_ end progn
       (alert "Nix zum auffrischen da :-(")
     ) ;_ end if    
    ) ;_ DialogEnd Refreshing

;;; **************************************************************************

        ((= DialogEnd 0) ;_ cancel
     (princ "\n...na dann halt nicht...bye")
    ) ;_ DialogEnd abbrechen
  ) ;_ end cond
  
;;; **************************************************************************
      
  (princ)
) ;_ end defun

(princ
  "\nBenwisch's DiaViewer - START: bw_view ...geladen\n"
) ;_ end princ

;;; *********
;;; FUNCTIONS
;;; *********

(defun bw_help (verDate ht progName / _dialog helpText x y)
  (setq	_dialog	  (load_dialog "bw_view.dcl")
	helpText  (bw_readHT ht);_ end list
  ) ;_ end setq
  (if _dialog
    (new_dialog "info" _dialog)
    (progn (alert (strcat "Kann Dialog " _dialog " nicht initialisieren!")) (exit)) 
  ) ;_ end if 
  (set_tile "text1"
	    (strcat progName verDate "<--")
  ) ;_ end  set_tile
  (set_tile "text2"
	    "_____________________________________________________________________"
  ) ;_ end  set_tile
  (set_tile "text3" "     Autor          : Rolf \"Benwisch\" Wischnewski          ")
  (set_tile "text4" "     Homepage :                                                         ")
  (set_tile "text5"
	    "     Email          : cad@benwisch.de                            "
  ) ;_ end  set_tile
  (set_tile "text6"
	    ""
  ) ;_ end  set_tile
  (set_tile "text7"
	    (strcat "Dieses Programm ist Freeware und Registriert fr : >>"
		    (getvar "LOGINNAME")
		    "<<."
	    ) ;_ end strcat
  ) ;_ end  set_tile
  (set_tile "text8"
	    (strcat (getvar "platform") " " (getvar "acadver") " " (getvar "_pkser"))
  ) ;_ end  set_tile
  (setq	x (dimx_tile "LOGOPIC")
	y (dimy_tile "LOGOPIC")
  ) ;_ end  setq
  (start_image "LOGOPIC")
  (fill_image 0 0 x y 0)
  (slide_image 0 0 x y "LOGOPIC")
  (end_image)
  (start_list "list")
  (mapcar 'add_list helpText)
  (end_list)
  (action_tile "accept" "(done_dialog 1)")
  (start_dialog)
) ;_ end  defun

;;; -------------------------------------------------------------------------------------

(defun bw_readHT (file / HELPTEXT HT OPFILE TXTFILE)
  (if (setq txtFile (findfile file))
    (progn (setq opFile (open txtFile "r")
		 ht (list)
		 )
	   (while (/= (setq helpText (read-line opFile)) nil)
	     (setq ht (cons helpText ht))
	   ) ;_ end while
	   (close opFile)
      (setq ht (reverse ht))
    ) ;_ end progn
    (alert (strcat "Kann " file " nicht finden."))
  ) ;_ end if
) ;_ end defun

;;; -------------------------------------------------------------------------------------

(defun bw_fillimage	(name / x y)
  (setq	x (dimx_tile (strcat "DIA" name))	  ; width  dialogbox
	y (dimy_tile (strcat "DIA" name))	  ; height dialogbox
  ) ;_ end setq
  (start_image (strcat "DIA" name))		  ; key
  (fill_image 0 0 x y 0) ;| fill box with black (fill_image fromX toY  width height color)|;
  (slide_image 0 0 x y (strcat "BW_DIAs\\" *oDwg* "-" name))
  (end_image)
) ;_ end defun

;;; -------------------------------------------------------------------------------------

(defun bw_getView (name /)
  (cond	((= 0 (cdr (assoc 70 (tblsearch "VIEW" name)))) ;_ Model
	 (if (/= (getvar "TILEMODE") 1)
	   (setvar "TILEMODE" 1)
	 ) ;_ end if
	 (setview (tblsearch "VIEW" name))
	 (princ (strcat "\n...hole gespeicherten Auschnitt <" name "> !  "))
	)
	((= 1 (cdr (assoc 70 (tblsearch "VIEW" name)))) ;_ Layout
	 (if (/= (getvar "TILEMODE") 0)
	   (setvar "TILEMODE" 0)
	 ) ;_ end if
	 (setview (tblsearch "VIEW" name))
	 (princ (strcat "\n...hole gespeicherten Auschnitt <" name "> !  "))
	)
  ) ;_ end cond
) ;_ end defun

;;; -------------------------------------------------------------------------------------

(defun bw_creaView (name / DiaName)
  (bw_creaFold (strcat (getvar "dwgprefix") "BW_DIAs")) ; check folder on harddisk
  (setq DiaName (strcat (getvar "dwgprefix") "BW_DIAs\\" *oDwg* "-" name))
  (command "'_-view" "s" name)
  (setvar "filedia" 0)
  (command "machdia" DiaName)
  (setvar "filedia" 1)
  (princ (strcat "\nAusschnitt <" name "> noch nicht vorh...wird erstellt !  "))
  (princ)
) ;_ end defun

;;; -------------------------------------------------------------------------------------

(defun bw_refView (name / DiaName)
  (bw_creaFold (strcat (getvar "dwgprefix") "BW_DIAs")) ; _check folder on harddisk
  (setq	DiaName (strcat (getvar "dwgprefix") "BW_DIAs\\" *oDwg* "-" name)
	*viewName*  name
  ) ;_ end setq
  (if (= 0 (cdr (assoc 70 (tblsearch "VIEW" name))))
    (setvar "TILEMODE" 1)
    (setvar "TILEMODE" 0)
  ) ;_ end if
  (command "'_-view" "h" name)
  (setvar "filedia" 0)
  (command "machdia" DiaName)
  (setvar "filedia" 1)
) ;_ end defun

;;; -------------------------------------------------------------------------------------

(defun bw_creaFold (folder)
  (if (not (vl-directory-files folder nil -1))
    (progn (vlax-invoke-method
	     (vlax-create-object "Scripting.FileSystemObject")
	     'createfolder
	     folder
	   ) ;_ end vlax-invoke-method
	   (vlax-release-object (vlax-create-object "Scripting.FileSystemObject"))
    ) ;_ end progn
  ) ;_ end if
  (princ)
) ;_ end defun

;;; -------------------------------------------------------------------------------------

(defun bw_fehler (s)
  (alert (strcat "\nIn einem laufenden Befehl nicht anwendbar !!!!"
		 "\nBitte erst den laufenden Befehl beenden !"
	 ) ;_ end  strcat
  ) ;_ end  alert
  (princ)
) ;_ end  defun